package cn.com.qmth.examcloud.core.basic.service.impl;

import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.OutputStream;

import javax.imageio.ImageIO;

import org.apache.poi.util.IOUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.google.code.kaptcha.impl.DefaultKaptcha;

import cn.com.qmth.examcloud.commons.base.exception.ExamCloudRuntimeException;
import cn.com.qmth.examcloud.core.basic.service.ImgCodeService;

/**
 * 类注释
 *
 * @author WANGWEI
 * @date 2018年12月26日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@Service
public class ImgCodeServiceImpl implements ImgCodeService {

	@Autowired
	DefaultKaptcha defaultKaptcha;

	@Override
	public String generate(OutputStream out) {
		try {
			String createText = defaultKaptcha.createText();
			BufferedImage challenge = defaultKaptcha.createImage(createText);
			ImageIO.write(challenge, "jpg", out);
			return createText;
		} catch (IOException e) {
			throw new ExamCloudRuntimeException(e);
		} finally {
			IOUtils.closeQuietly(out);
		}
	}

}
